#include <stdio.h>
#include <stdlib.h>


struct node{
    int data;
    struct node* next;
};

void printlist(struct node* curr){

    while(curr != NULL){
        printf("%d --> ", curr->data);
        curr = curr->next;
    }
    printf("\n");

}

int addBack(struct node** head, int val){
    struct node* prev = NULL;
    struct node* curr = *head;

    while(curr != NULL){
        prev = curr;
        curr = curr->next;
    }

    struct node* t = (struct node*) malloc(sizeof(struct node));
    if(t == NULL) return -1;
    t->data = val;
    t->next = NULL;

    if(prev != NULL){
        prev->next = t;
    }else{
        *head = t;
    }

    return 0;

}

int main(){

    struct node *head = NULL;

    for(int i=0;i<10;i++){
        struct node* t = (struct node*) malloc(sizeof(struct node));
        t->data =i;
        t->next = head;
        head = t;
    }


    printlist(head);

    addBack(&head,14);

    printlist(head);

    addBack(&head,18);

    printlist(head);

    return 0;

}


